"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _factory = require("./factory");

var _factory2 = _interopRequireDefault(_factory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CallbackStore = function () {
  function CallbackStore() {
    _classCallCheck(this, CallbackStore);
  }

  _createClass(CallbackStore, [{
    key: "init",
    value: function init() {
      this.state({ cache: {} });
    }
  }, {
    key: "cached",
    value: function cached(_ref) {
      var callback = _ref.callback;
      var name = _ref.name;
      var variant = _ref.variant;
      var converted = _ref.converted;
      var cache = _ref.state.cache;

      var key = name + ":" + variant + ":" + converted;
      var value = cache[key];

      if (callback) {
        cache[key] = true;
        this.state({ cache: cache });
      }

      return value;
    }
  }, {
    key: "run",
    value: function run(_ref2) {
      var args = _ref2.args;
      var _ref2$state = _ref2.state;
      var cache = _ref2$state.cache;
      var callback = _ref2$state.callback;

      var _cached = this.cached(_extends({}, args, { callback: callback }));

      var value = _cached.value;


      if (!value && callback) {
        callback(args);
      }

      return value;
    }
  }]);

  return CallbackStore;
}();

exports.default = (0, _factory2.default)(CallbackStore);
//# sourceMappingURL=callback_store.js.map