"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _factory = require("./factory");

var _factory2 = _interopRequireDefault(_factory);

var _jsCookie = require("js-cookie");

var _jsCookie2 = _interopRequireDefault(_jsCookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Cookie = function () {
  function Cookie() {
    _classCallCheck(this, Cookie);
  }

  _createClass(Cookie, [{
    key: "init",
    value: function init() {
      this.state({ cookie: { expires: 10 * 365 } });
    }
  }, {
    key: "read",
    value: function read(_ref) {
      var name = _ref.name;

      if (typeof document == "undefined") {
        return {};
      } else {
        return { variant: _jsCookie2.default.get(name) };
      }
    }
  }, {
    key: "write",
    value: function write(_ref2) {
      var name = _ref2.name;
      var variant = _ref2.variant;
      var cookie = _ref2.state.cookie;

      if (typeof document == "undefined") {
        return {};
      } else {
        return _jsCookie2.default.set(name, variant, cookie);
      }
    }
  }]);

  return Cookie;
}();

exports.default = (0, _factory2.default)(Cookie);
//# sourceMappingURL=cookie.js.map